Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  Lisp
  Text in Tabelle wählen

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Text in Tabelle wählen (164 mal gelesen)
Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1151
Registriert: 11.01.2006

WIN 10
ACAD 2017

erstellt am: 30. Okt. 2019 14:49    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo zusammen,
wenn ich mit entsel oder nentsel auf einen Text in einer Tabellenzelle klicke bekomme ich nil  .

Ich würde aber gerne irgendwie den Text anklicken und eine verwertbare Rückgabe bekommen.
Gibts da einen Trick dabei ?

------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

cadffm
Moderator
良い精神




Sehen Sie sich das Profil von cadffm an!   Senden Sie eine Private Message an cadffm  Schreiben Sie einen Gästebucheintrag für cadffm

Beiträge: 19452
Registriert: 03.06.2002

System: F1
und Google

erstellt am: 30. Okt. 2019 15:18    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Andreas Kraus 10 Unities + Antwort hilfreich

ActiveX Welt
Schau dir die HITTEST Methode des Tabellenobjektes an: TABLE
Natürlich kannst du jetzt darüber hinaus/danach auch super
AutoCAD table hittest
als Searchstring für die Suchmaschiene deiner Wahl nutzen.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Andreas Kraus
Mitglied
Elektrotechniker


Sehen Sie sich das Profil von Andreas Kraus an!   Senden Sie eine Private Message an Andreas Kraus  Schreiben Sie einen Gästebucheintrag für Andreas Kraus

Beiträge: 1151
Registriert: 11.01.2006

WIN 10
ACAD 2017

erstellt am: 04. Nov. 2019 16:03    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

DAAAANKE  
hat geholfen, hatte nur eben erst Zeit dafür.

Hier das Programm in der "ersten Version".
Kann man ja noch ausbauen

Code:
(defun k_satz->objlist (satz)
;;; Objektliste aus Auswahlsatz erstellen
  (mapcar 'vlax-ename->vla-object (k_satz->entlist satz))
)

(defun k_get-textstring (ent_name / ent_data)
;;; wie vla-get-textstring, aber aus Elementdaten zusammengebaut um auch Sonderzeichen lesen zu können die im Textstring vom Objekt nicht vorhanden sind
  (setq ent_data
(cond
   ((= (type ent_name) 'VLA-OBJECT)
    (entget (vlax-vla-object->ename ent_name))
   )
   ((= (type ent_name) 'ENAME)
    (entget ent_name)
   )
   ((= (type ent_name) 'LIST)
    ent_name
   )
)
  )
  (cond
    ((= (cdr (assoc 0 ent_data)) "ATTDEF")
     (apply 'strcat
    (mapcar 'cdr
    (vl-remove-if-not
      '(lambda (data) (member (car data) '(1 3)))
      (vl-remove (assoc 3 ent_data) ent_data)
    )
    )
     )
    )
    ((member (cdr (assoc 0 ent_data)) '("TEXT" "MTEXT" "ATTRIB"))
     (strcat (cdr
       (last (vl-remove-if-not
       '(lambda (data) (= (car data) 1))
       ent_data
     )
       )
     )
     (apply 'strcat
    (mapcar 'cdr
    (vl-remove-if-not
      '(lambda (data) (= (car data) 3))
      ent_data
    )
    )
     )
     )
    )
    ((member (cdr (assoc 0 ent_data)) '("MULTILEADER"))
     (vla-get-textstring
       (vlax-ename->vla-object (cdr (assoc -1 ent_data)))
     )
    )
    (t nil)
  )
)

(defun c:k_txt->tbl (/ COL DUMMY P PIC ROW TBL TBL_LIST TEXT_LISTE)
;;;  Textinhalte in Tabellenzellen übertragen
  (if
    (setq
      tbl_list
       (k_satz->objlist
(ssget
   "x"
   (list '(0 . "ACAD_TABLE") (cons 410 (getvar "ctab")))
)
       )
    )
     (progn
       (setq text_liste nil)
       (while (setq pic (nentsel))
(setq text_liste (cons (k_get-textstring (car pic)) text_liste))
       )
       (setq text_liste (reverse text_liste))
       (foreach text text_liste
(setq p (getpoint))
(if
   (setq dummy
  (car
    (vl-remove
      'nil
      (mapcar
'(lambda (tbl)
   (if
     (k_is (vla-hittest
     tbl
     (VLAX-3D-POINT p)
     (vlax-3D-point (trans '(0 0 1) 0 1))
     'row
     'col
   )
     )
      (list tbl row col)
   )
)
tbl_list
      )
    )
  )
   )
    (vla-SetText (nth 0 dummy) (nth 1 dummy) (nth 2 dummy) text)
)
       )
     )
  )

)


------------------
Geht nicht, gibts nicht

Gruß
Andreas

http://kraus-cad.de

[Diese Nachricht wurde von Andreas Kraus am 04. Nov. 2019 editiert.]

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2019 CAD.de | Impressum | Datenschutz